import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class ProofMonitor {
    int X,Y;
    int size;
    String time;
    double VOLUME;
    double[] PARALLEL=new double[8];
    ControlPanel ACTION;
    ListenSquare INTERVAL;
    int MODE=0;
    long PASSED;
    int MAXDEPTH;
    int LENGTH;
    int MAXLENGTH;
    double K;
    int[] CURRENTDEPTH=new int[4];;


    public ProofMonitor(int XX,int YY) {
	X=XX;
	Y=YY;
	time="";
	VOLUME=0;
	size=-2;
	MAXDEPTH=0;
    }

    public void render(Graphics2D g) {
	Color[] COL={new Color(230,0,0),new Color(255,130,0),new Color(255,255,0),new Color(0,250,0),
		     new Color(0,180,180),new Color(30,50,255),new Color(130,0,255),new Color(200,0,230)};
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.setColor(new Color(0,0,10));
	g.fillRect(X,Y,394,200);
	g.setColor(Color.white);
	g.drawRect(X,Y,394,200);
	renderBar(g,95,40,VOLUME,new Color(0,0,255),new Color(255,255,255));
	for(int i=0;i<8;++i) renderBar(g,32+5*i,5,8*PARALLEL[i],new Color(0,0,255),COL[i]);
	renderProgress(g);
    }


    public void renderBar(Graphics2D g,double y,double h,double vol,Color C1,Color C2) {
	Path2D.Double gp=new Path2D.Double();
	
	gp.moveTo(X+2,Y+y);
	gp.lineTo(X+2,Y+y+h);
	gp.lineTo(X+390+1,Y+y+h);
	gp.lineTo(X+390+1,Y+y);
	gp.closePath();
	g.setColor(C1);
	g.draw(gp);

	gp.reset();
	gp.moveTo(X+2,Y+y);
	gp.lineTo(X+2,Y+y+h);
	double s=390*vol;
	gp.lineTo(X+s+2,Y+y+h);
	gp.lineTo(X+s+2,Y+y);
	gp.closePath();
	g.setColor(C2);
	g.fill(gp);
    }

    public void renderProgress(Graphics2D g) {
	Long pass=new Long(PASSED);
	Long depth=new Long(MAXDEPTH);
	Integer length=new Integer(LENGTH);
	Integer maxlength=new Integer(MAXLENGTH);

	/**time display*/
	g.setFont(new Font("Helvetica",Font.PLAIN,20));
	g.setColor(new Color(255,100,255));
	g.drawString("time   "+time,X+10,Y+20);

	/**partition progress display*/
	g.setColor(new Color(0,0,255));
	g.setFont(new Font("Helvetica",Font.PLAIN,16));
	g.setColor(new Color(110,150,255));
	g.setColor(Color.white);
	g.drawString("("+pass.toString()+")",X+270,Y+155);

	/**volume display*/
	g.setColor(Color.white);
	g.setFont(new Font("Helvetica",Font.PLAIN,18));
	Double P=new Double(VOLUME);
	g.drawString("volume "+P.toString(),X+10,Y+155);	
        g.setColor(new Color(0,100,255));

	g.setColor(new Color(0,255,0));
	g.setFont(new Font("Helvetica",Font.PLAIN,15));
	g.drawString("list length "+length.toString(),X+10,Y+175);
	g.drawString("max length: "+maxlength.toString(),X+260,Y+175);

	g.setColor(new Color(255,180,0));
	g.drawString("max depth "+depth.toString(),X+260,Y+195);
	g.drawString("current depth",X+10,Y+195);
	for(int i=0;i<4;++i) {
	    Integer x=new Integer(CURRENTDEPTH[i]);
	    g.drawString(x.toString(),X+120+30*i,Y+195);
	}



    }

}



