import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends Canvas implements MouseListener {

    ListenSquare GO,HALT;  //stop/go
    Proof PROOF;
    String[] S=new String[4];


    /*This main routine makes the window*/
     public ControlCanvas() {
	 addMouseListener(this);
	GO=new ListenSquare(0,120,25,20,Color.red); GO.on=1;
	HALT=new ListenSquare(25,120,35,20,Color.red); HALT.on=1;
	PROOF=new Proof();
	for(int i=0;i<4;++i) S[i]="";
     }

    /**main rendering routine for the control panel*/
   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      makeFrame(g);
      drawControls(g);
      drawMessages(g);
   }


    /*draws the background*/
    public void makeFrame(Graphics2D g) {
    g.setColor(new Color(100,0,160));
      g.fillRect(0,0,getWidth(),getHeight()); 
    }

    /**draws the control panel*/
    public void drawControls(Graphics2D g) {
      g.setFont(new Font("Helvetica",Font.PLAIN,12));
      if(PROOF.HALT==true) { 
          GO.render(g,new Color(0,180,0));
          g.drawString("go",(int)(GO.x+5),(int)(GO.y+15));
      }
      if(PROOF.HALT==false) { 
          HALT.render(g,new Color(220,0,0));
          g.drawString("stop",(int)(HALT.x+5),(int)(HALT.y+15));
      }
    }

    /**This draws messages it gets from the main calculation*/
    public void drawMessages(Graphics2D g) {
	g.setColor(Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	for(int i=0;i<4;++i) g.drawString(S[i],120,20+25*i);
    }


    /**run and stop the main calculation*/
     public void doRun() {
	 if(PROOF.HALT==false) return;
         PROOF=new Proof(this);
	 new Thread(PROOF).start();
    }

    public void doStop() {
	PROOF.HALT=true;
    }

    /**This gets the energy hybrid data*/
    public int[][] getEnergy() {
	 int[][] E={{1,3},{0,0},{0,0}};
	 return E;
    }

    /**This gets the specs for the elimination step*/
    public int[] getEliminationSpecs() {
	int[] E={1,1,0,0};
	return E;
    }
    
    /**handling mouse events*/
    public void mouseClicked(MouseEvent e) { 
        MouseData J=MouseData.process(e);
	if(GO.inside(J.X)==1) doRun();
	if(HALT.inside(J.X)==1) doStop();
        repaint();
    }

    /**not used but need to be here*/
    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
    public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


}

