
public class ProofGrading {

    /**The exact ordering is deliberate. 
       rigor specifies whether to test the successful floating point operations with a further interval calculation.
       elim specifies which things we test for. */

    public static int[] main(int[] elim,int[][] E,Block X) {
	
	int choice=getType(E); //this determines whether we have a monotone decreasing potential or not
	
	if(tooSmall(X)==true) finalFail(X); //this happens if there are too many subdivisions.
	
        int[] pass={1,0};
	
	int s=sideTooLong(X);  //this fails if the side length is greater than 2.  
	if(s!=-1) return fail(s);
	

	if(elim[0]==1) {  //this eliminates configurations not in Omega
   	    if(EliminateOutsideOmega.main(choice,X)>0) return pass;
	}

	if(elim[1]==1) {  //this eliminates configurations in the tiny cube near the TBP even avatar
	   if(EliminateInsideOmega0.main(X)==true) return pass;
	}

	if(elim[2]==1) {  //this is used for the potential G_10^sharp,
	   if(EliminateInsideUpsilon.main(X)==true) return pass;
	}

	if(elim[3]==1) {   //this is used for the potential G_10^double sharp
	    if(EliminateOutsideUpsilon.main(X)==true) return pass;
	}

	//here is the main energy test
	int[] floating_version=EliminateEnergy.main(E,X);
	if(floating_version[0]==0) return floating_version;
	int[] interval_version= EliminateEnergyInterval.main(E,X);  
	return interval_version;
    }

    public static void finalFail(Block X) { 
        X.print();
        throw new ProofException("too many subdivisions");
    }


    public static int sideTooLong(Block X) {
	for(int i=1;i<4;++i) {
            if(X.B[i].k<-1) return(i);
	}
	return -1;
    }

    public static int[] fail(int i) {
	int[] f={0,i};
	return f;
    }

    public static boolean tooSmall(Block X) {
	for(int i=0;i<4;++i) {
	    if(X.B[i].k>=Box.SCALE-1) return true;
	}
	return false;
    }	

    /**This returns 1 when we run a power combo with some negative coefficients.
       Otherwise this returns 0.  
       This classification is only meant to work for the combos:
       0. G4, G5, G6
       1. G5_flat
       2. G10_sharp and G10_sharp2
    */

    public static int getType(int[][] E) {
        boolean special=false;
	for(int i=0;i<3;++i) {
	    if(E[i][0]<0) return 1;
	}
	return 0;

    }

}


