import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;




public class PictureCanvas extends ScaleCanvas implements KeyListener,MouseListener, MouseMotionListener {
    Manager M;  
    ListenSquare BLOCK;
    Path2D.Double DEBUG1,DEBUG2,DEBUG3;
    double DEBUG_RANGE1,DEBUG_RANGE2;
    HSlider RANGE;
    HSlider EXPONENT;
    Point JX;
    ListenSquare INFO;
    Output OUT;

     public PictureCanvas() {
	 addMouseListener(this);
	 addKeyListener(this);
	 addMouseMotionListener(this);	 
	 setScales(20,220,160);
	 BLOCK=new ListenSquare(0,0,400,70);
	 DEBUG1=null;
	 DEBUG2=null; 
         Color[] C1={new Color(50,100,255),Color.white,Color.white};
         Color[] C2={new Color(200,0,200),Color.white,Color.white};
	 RANGE=new HSlider(0,0,400,30,200,C1,"plot range: from x to 2");
	 EXPONENT=new HSlider(0,35,400,30,200,C2,"exponent");
	 INFO=new ListenSquare(0,0,12,12);
     }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                         RenderingHints.VALUE_ANTIALIAS_ON);
      drawFrame(g); 
      drawPlot(g); 
      drawDebug1(g);
      drawDebug2(g);
      drawControls(g);
      if(M.C.EXPORT.mode==2) exportPlot();
   }

    public void drawFrame(Graphics2D g) {
	g.setColor(new Color(0,0,50));
	g.fillRect(0,0,getWidth(),getHeight());
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-10,0);
	gp.lineTo(10,0);
	gp.moveTo(0,-10);
	gp.lineTo(0,10);
	gp=transform(gp);
	g.setColor(new Color(50,100,255));
	g.draw(gp);
	gp.reset();
	gp.moveTo(Math.sqrt(2),-10);
	gp.lineTo(Math.sqrt(2),10);
	gp.moveTo(Math.sqrt(3),-10);
	gp.lineTo(Math.sqrt(3),10);
	gp.moveTo(2,-10);
	gp.lineTo(2,10);
	gp=transform(gp);
	g.setColor(new Color(0,100,100));	
        g.draw(gp);




	
    }


    public void exportPlot() {
	OUT=new Output("Output/graph");
	Path2D.Double x=new Path2D.Double();
	x.moveTo(-100,0);
	x.lineTo(+100,0);
	OUT.lineWrite(x,new Color(150,150,150));
	x.reset();
	x.moveTo(Math.sqrt(2),-100);
	x.lineTo(Math.sqrt(2),+100);
	OUT.lineWrite(x,new Color(150,150,150));
	x.reset();
	x.moveTo(Math.sqrt(3),-100);
	x.lineTo(Math.sqrt(3),+100);
	OUT.lineWrite(x,new Color(150,150,150));
	x.reset();
	x.moveTo(Math.sqrt(4),-100);
	x.lineTo(Math.sqrt(4),+100);
	OUT.lineWrite(x,new Color(150,150,150));

	Path2D.Double gp=getPlot();
	OUT.lineWrite(gp,Color.black);
    }


    public void drawPlot(Graphics2D g) {
	Path2D.Double gp=getPlot();
	gp=transform(gp);
	g.setColor(Color.white);
	g.draw(gp);
    }


    public Path2D.Double getPlot() {

	EnergyCombo[] d=M.C.ENG;
     	double ex=getExponent();
	double[] A=M.C.getTarget();
 	double[] e=new double[5];
	e=ComputeCombo5.coeffList(d,A,ex);
	double y2=0;
	Path2D.Double gp=new Path2D.Double();
	double y0=0;

	int rv=(int)(2*RANGE.getValue()*500);

	for(int i=rv;i<=1000;++i) {
	    double x=1.0*i/500;
	    double y1=SpecialFunctions.R(ex,x);
	    y2=ComputeCombo5.cone(e,d,x);
	    double sign=1;
	    if(ex<0) sign=-1;
	    double y=sign*(1-y2/y1);
	    if(y0<y) y0=y;
	    if(i==rv) gp.moveTo(x,y);
	    if(i>rv) gp.lineTo(x,y);
	}
	AffineTransform SC=AffineTransform.getScaleInstance(1,1/y0);
	gp.transform(SC);
	return gp;
    }

    public void drawDebug1(Graphics2D g) {
	if(DEBUG1==null) return;	
	double s=1/DEBUG_RANGE1;
	Path2D.Double gp=new Path2D.Double(DEBUG1);
	AffineTransform SC=AffineTransform.getScaleInstance(1,s);
	gp.transform(SC);
        gp=transform(gp);
	g.setColor(Color.yellow);
	g.draw(gp);
    }

    public void drawDebug2(Graphics2D g) {
	if(DEBUG2==null) return;	
	double s=1/DEBUG_RANGE2;
	Path2D.Double gp=new Path2D.Double(DEBUG2);
	AffineTransform SC=AffineTransform.getScaleInstance(1,s);
	gp.transform(SC);
        gp=transform(gp);
	g.setColor(new Color(255,0,80));
	g.draw(gp);
    }

    public void drawControls(Graphics2D g) {
	BLOCK.w=this.getWidth();
        BLOCK.render(g,new Color(0,0,150));  
      
        EXPONENT.render(g);
	double d=EXPONENT.getValue();
	d=-2*(1-d)+16*d;
	Double D=new Double(d);
	g.setColor(Color.white);  
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.drawString(D.toString(),10,EXPONENT.h+20);
	g.drawString("click/drag to change exponent",150,EXPONENT.y+20);


	RANGE.render(g); 
	D=new Double(2*RANGE.getValue());
	g.setColor(Color.white);
	g.drawString("x="+D.toString(),30,14);
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.drawString("click/drag to change range",150,RANGE.y+20);
	INFO.infoRender(g);

    }

    public double getExponent() {
 	double d=EXPONENT.getValue();
	double e=-2*(1-d)+16*d;
	return e;
    }

    public void mousePressed(MouseEvent e) { }


    public void mouseClicked(MouseEvent e) {  
       MouseData J=MouseData.process(e);
       doMouseClick(J.mode,J.X);
    }

    public void doMouseClick(int mode,Point X) {
       if(BLOCK.inside(X)!=1) {
         if(mode==3) scaleUp(X,1);
         if(mode==1) scaleUp(X,-1);
       }
       if(INFO.inside(X)==1) DocumentApprox.main(M.D);
       M.repaint();
    }

     public void mouseReleased(MouseEvent e) {	 
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }

     public void mouseExited(MouseEvent e) {
     }

    public void mouseMoved(MouseEvent e) {  
        MouseData J=MouseData.process(e);
	JX=J.X;
    }

    public void mouseDragged(MouseEvent e) {  
       MouseData J=MouseData.process(e);
       RANGE.modify(J.X);
       EXPONENT.modify(J.X);
       repaint();
    }


    public void keyTyped(KeyEvent e) { 
	char ch=e.getKeyChar();
	int mode=0;
	if(ch=='z') mode=1;
	if(ch=='x') mode=2;
	if(ch=='c') mode=3;
	if(ch=='b') mode=1;
	if(ch=='n') mode=2;
	if(ch=='m') mode=3;
	doMouseClick(mode,JX);
	repaint();
    }
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}


}

