
(*This file does the calculations of the functions GAMMA and BETA*)
(*For Lemma A222. This file is meant to be a sanity check for our*)
(*Java program which has the formal proof*)

            
Clear[G,k,r,COMBO,MATX,MATX0,EVAL1,EVAL2,GAMMA0,GAMMA1,GAMMA2,GAMMA3,GAMMA4];          

(*Here are the basic functions*)
R0=Power[r,-s];
R1=-s Power[r,-s-1];
G[k_,r_]:=Power[4 - r r,k];

(*The special distances that arise in the TBP*)
s2=Sqrt[2];
s3=Sqrt[3];
s4=Sqrt[4];

(*Here is the quintuple*)
GAMMA0=1;
GAMMA1=G[1,r];
GAMMA2=G[2,r];
GAMMA3=G[5,r];
GAMMA4=G[10,r];

(*Here is the combo*)
C0=a0 + a1 GAMMA1 + a2 GAMMA2 + a3 GAMMA3 + a4 GAMMA4;
(*and its derivative*)
C1=D[C0,r];

(*This extracts the matrix*)
MATX0={C0//.r->s2,C0//.r->s3,C0//.r->s4,C1//.r->s2,C1//.r->s3};
EVAL0[X_]:=MATX0//.{a0->X[[1]],a1->X[[2]],a2->X[[3]],a3->X[[4]],a4->X[[5]]}
EVAL1[k_]:=(TEMP=IdentityMatrix[5];EVAL0[TEMP[[k]]]);
MATX=Table[EVAL1[k],{k,1,5}];

(*Here are the coefficients*)
MATX2=Inverse[MATX];
MATX2[[4]]=-MATX2[[4]]/Sqrt[2];
MATX2[[5]]=-MATX2[[5]]/Sqrt[3];
MATX2=Transpose[MATX2];
VEC={Power[s2,-s],Power[s3,-s],Power[s4,-s],s Power[s2,-s],s Power[s3, -s]};
COEFF=MATX2.VEC;

(*Here is the interpolation function Lambda*)
LAMBDA=COEFF[[1]] GAMMA0+ COEFF[[2]] GAMMA1 + COEFF[[3]] GAMMA2 + COEFF[[4]] GAMMA3 + COEFF[[5]] GAMMA4;

PSI= Simplify[(s LAMBDA + r D[LAMBDA,r])/.r->Sqrt[4-t]];

(*Here is the phi polynomial*)
PHI0= Simplify[(s LAMBDA + r D[LAMBDA,r])//.r->Sqrt[4-4 u]];
PHI1=Sum[Simplify[Coefficient[PHI0,u,k] Power[u,k]],{k,0,10}];
PHI2=(1/4) D[PHI1,u];

(*Here is the combo for 33567 PHI1[u=0]*)
 Y0={-88440,-503040,591480,4254,65728,33567};
 (*Here is the cobo for 33567 PHI1[u=4]/s*)
 VEC={Power[2,-s/2],Power[3,-s/2],Power[4,-s/2],s Power[2,-s/2],s Power[3,-s/2],s Power[4,-s/2]};
Y4={-48973248, 32866944, 16139871, 4141935, 8107680, 0};

	       
(*Here is the construction of the function GAMMA from the proof*)
poly1 = -546840 + 18366*s - 1800480*t + 17112*s*t + 99720*t^2 + 80766*s*t^2 - 
     397440*t^3 + 24288*s*t^3 - 234600*t^4 + 18630*s*t^4 - 33120*t^5 + 
	       11592*s*t^5 + 173880*t^6 + 4830*s*t^6 - 22080*t^7 - 1104*s*t^7;
 
poly2 = -345600 - 199296*s + 7104*s^2 - 1576320*t - 698784*s*t + 8432*s^2*t - 
     509760*t^2 + 75216*s*t^2 + 33960*s^2*t^2 - 760320*t^3 - 149376*s*t^3 + 
     11968*s^2*t^3 - 448800*t^4 - 79960*s*t^4 + 9180*s^2*t^4 - 63360*t^5 + 
     5856*s*t^5 + 5712*s^2*t^5 + 332640*t^6 + 94920*s*t^6 + 2380*s^2*t^6 - 
	       42240*t^7 - 12992*s*t^7 - 544*s^2*t^7;

poly3 = 892440 - 73350*s + 1473*s^2 + 3376800*t - 246888*s*t + 4092*s^2*t + 
     410040*t^2 - 228942*s*t^2 + 10557*s^2*t^2 + 1157760*t^3 - 165792*s*t^3 + 
     5808*s^2*t^3 + 683400*t^4 - 110370*s*t^4 + 4455*s^2*t^4 + 96480*t^5 - 
     41688*s*t^5 + 2772*s^2*t^5 - 506520*t^6 + 27510*s*t^6 + 1155*s^2*t^6 + 
	       64320*t^7 - 2064*s*t^7 - 264*s^2*t^7;

GAMMA=poly1 Power[3,s/2] + poly2 Power[4,s/2]+ poly3 Power[6,s/2];

BETA=Factor[PSI][[6]];
(*This shows that our formula for GAMMA is correct*)
{Simplify[(D[BETA,{t,2}]-D[BETA,t])/GAMMA],Factor[PSI/BETA]}


