import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**This file runs the tests*/

public class RunTests {

    /**For Lemma A221*/

    public static void lemmaA221(int choice) {

       	System.out.println("START "+choice);
	
	//these are the various limits for the tests
	BigRational s0=new BigRational(0,1);
	BigRational x=new BigRational(1,4);
	BigRational s4=new BigRational(4,1);
	BigRational s6=new BigRational(6,1);
	BigRational s8=new BigRational(8,1);
	BigRational s13=new BigRational(13,1);
	BigRational s16=new BigRational(16,1);
	BigRational y=new BigRational(7705,512);


	//gets the data for the tests
	long[][] m=new long[0][0];
	if(choice==0)  m=Data.dataA221case1();
	if(choice==1)  m=Data.dataA221case2();
	if(choice==2)  m=Data.dataA221case3();

	//The interval [1/4,6].  For choice = 0.
	BigRational L=new BigRational(s0);
	BigRational L0=new BigRational(x);
	BigRational R=new BigRational(s8);
	BigRational R0=new BigRational(s6);

	//the interval [6,13].  For choice = 1
	if(choice==1) {
	   L=new BigRational(s0);
	   L0=new BigRational(s6);
    	   R=new BigRational(s16);
	   R0=new BigRational(s13);
	}

	//the interval [15,15+25/512]. For choice = 2
	if(choice==2) {
	   L=new BigRational(s0);
	   L0=new BigRational(s13);
    	   R=new BigRational(s16);
	   R0=new BigRational(y);
	}

	//check the positivity
	for(int i=0;i<m.length;++i) {
	    System.out.print("test "+i+":  ");
	    PowerCombo A=PowerComboExtract.extract(m[i]);
	    PowerCombo.testPositive(A,L,R,L0,R0);
	}
	System.out.println("ALL DONE");
    }

    /**For the small part of Lemma A222*/
    
    public static void lemmaA222Small() {
	//the interval is [6,16]
	BigRational s6=new BigRational(6,1);
	BigRational s16=new BigRational(16,1);

	System.out.println("START ");
	for(int i=0;i<2;++i) {
	    System.out.print(i+"  ");
	    PowerCombo A=PowerComboExtract.extractSmall(i);
	    PowerCombo.testPositive(A,s6,s16,s6,s16);
	}
	System.out.println("ALL DONE");
    }
    

    /**For the big part of Lemma A222*/
    
    public static void lemmaA222Big() {
	//the interval is [6,16]
	BigRational s6=new BigRational(6,1);
	BigRational s16=new BigRational(16,1);

	System.out.println("START ");

	for(int i=0;i<128;++i) {
	    System.out.print(i+"  ");
	    PowerCombo A=PowerComboExtract.extractBig(i);
	    PowerCombo.testPositive(A,s6,s16,s6,s16);
	}
	
	System.out.println("ALL DONE");
    }
    
}

