import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class ControlCanvas extends ScaleCanvas implements MouseListener,MouseMotionListener {
    Manager M;
    ListenSquare GO,STOP;
    SymmetrizeTester SYMM=new SymmetrizeTester();
    SelectInteger RANGE1,RANGE2;  
    ControlPanel DISPLAY;
    SelectInteger[] CUSTOM=new SelectInteger[8];
    Color[] COL=new Color[4];
    ListenSquare[] STATUS=new ListenSquare[5];
    int[] STATUS0=new int[5];

     public ControlCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 GO=new ListenSquare(5,5,40,20);
	 STOP=new ListenSquare(55,5,40,20);
	 SYMM=new SymmetrizeTester();
	 RANGE1=new SelectInteger(5,55,40,20,2,0,100,1);
	 RANGE2=new SelectInteger(105,55,40,20,16,0,100,1);
	 COL[0]=new Color(110,0,250);		
	 COL[1]=new Color(255,0,150);	
	 COL[2]=new Color(0,0,250);
	 COL[3]=new Color(250,0,150);
	 for(int i=0;i<7;++i) CUSTOM[i]=new SelectInteger(-1000,0,0,0,0,0,0,0);
	 CUSTOM[0]=new SelectInteger(10,425,40,20,432,0,800,1); 
	 CUSTOM[1]=new SelectInteger(10,450,40,20,498,0,800,1);  
	 CUSTOM[2]=new SelectInteger(10,475,40,20,32,0,256,1); 
	 CUSTOM[3]=new SelectInteger(10,500,40,20,348,0,800,1); 
	 CUSTOM[4]=new SelectInteger(10,525,40,20,465,0,800,1);  
	 CUSTOM[5]=new SelectInteger(10,550,40,20,32,0,256,1);    
	 CUSTOM[6]=new SelectInteger(110,425,50,25,4,0,9,1); 
	 for(int i=0;i<5;++i) {
             STATUS0[i]=0;
	     STATUS[i]=new ListenSquare(0,210+30*i,30,30);
	 }
	 panelSetup();
     }


    public void panelSetup() {
      Color[] C0={new Color(80,160,255),Color.white,
      Color.white,Color.black,Color.red};
      Color[] C1={new Color(255,50,255),Color.white,
      Color.white,Color.black,Color.red};
      String[] DisplayString={"initial","symmetrized","display"};
      int[] DisplayState={1,1};
      DISPLAY=new ControlPanel(C0,DisplayString,DisplayState,2);
      DISPLAY.mode=0;
    }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawControls(g);
      drawStatus(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(Color.blue);
        g.fillRect(0,0,getWidth(),getHeight()); 
    }

    public void drawControls(Graphics2D g) {
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.setColor(Color.white);

	if(SYMM.HALT==true) {
            GO.render(g,new Color(0,180,0));
	    g.drawString("go",(int)(GO.x+5),(int)(GO.y+15));
	}

	if(SYMM.HALT==false) {
            STOP.render(g,new Color(220,0,0));
	    g.drawString("stop",(int)(STOP.x+5),(int)(STOP.y+15));
	}

	g.drawString("exponent lower and upper limits",5,89);
	DISPLAY.render2(g,5,125,90);
	RANGE1.render(g,Color.red,Color.white,Color.white);
	RANGE2.render(g,Color.red,Color.white,Color.white);
	for(int i=0;i<3;++i) CUSTOM[i].render(g,COL[0],Color.white,Color.white);
	for(int i=3;i<6;++i) CUSTOM[i].render(g,COL[1],Color.white,Color.white);
	CUSTOM[6].render2(g,Color.red,Color.white,Color.white);
        g.setFont(new Font("Helvetica",Font.PLAIN,16));
	g.drawString("2",130,280);
	g.drawString("0",180,280);
	g.drawString("3",155,250);
	g.drawString("1",155,310);
        g.setFont(new Font("Helvetica",Font.PLAIN,12));
	g.drawString("customize region (coord=val/512)",5,410);
    }



    public void drawStatus(Graphics2D g) { 
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	Color C=new Color(0,0,0);
	String[] S={"total","01+12","03+23","02+02+24","13+14+34"};
	for(int i=0;i<5;++i) {
	  if(STATUS0[i]==-1) C=new Color(255,0,0);
	  if(STATUS0[i]==+1) C=new Color(0,200,0);
	  if(STATUS0[i]==+2) C=new Color(255,200,0);
	  g.setColor(Color.white);
	  g.drawString(S[i],40,(int)(STATUS[i].y+20));
	  STATUS[i].render(g,C);
	}
    }




    public void doStop() {
	SYMM.HALT=true;
    }

    public void doGo() {
	if(SYMM.HALT==false) return; 
	SYMM=new SymmetrizeTester(this.M);
        new Thread(SYMM).start();
    }

    public void customize(Point X) {
	CUSTOM[6].modify(X);
	for(int i=0;i<6;++i) {
	    int step=CUSTOM[6].val;
	    step=(int)(Math.pow(2,step));
	    CUSTOM[i].step=step;
            CUSTOM[i].modify(X);
	}
    }

    public void mouseClicked(MouseEvent e) {
        MouseData J=MouseData.process(e);
	if(GO.inside(J.X)==1) doGo();
	if(STOP.inside(J.X)==1) doStop();
        DISPLAY.toggle(J.X);
	customize(J.X);
	RANGE1.modify(J.X);
	RANGE2.modify(J.X);
	repaint();
	M.P.repaint();
    }

    public void mouseDragged(MouseEvent e) {}
    public void mousePressed(MouseEvent e) {}
     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   
     public void mouseMoved(MouseEvent e) {}    

}

